## How to contribute to E3SM

#### **Did you find a bug?**

* Is it a bug in E3SM code? E3SM includes several codes that are developed
externally. 
See [LICENSE](LICENSE) for
locations and report your bug in the original developers site.

* Ensure the bug was not already reported by searching on our GitHub instance
under [Issues](https://github.com/E3SM-Project/E3SM/issues).

* If you are unable to find an open issue addressing the problem, open a new
one. Be sure to include a title, clear description, and as much relevant
information as possible, including the case, machine, compiler and compiler
version.

#### **Do you want to fix an existing bug?**

* Before you start writing code, please read [Developing
E3SM](http://e3sm.org/model/running-e3sm/developing-e3sm/) to know more about
our development workflow.

* Open a new GitHub pull request with the patch.

* Ensure the PR description clearly describes the problem and solution. Include
the relevant issue number if applicable.

#### **Did you fix whitespace, format code, or make a purely cosmetic patch?**

Changes that are cosmetic in nature and do not add anything substantial to the
stability, functionality, or testability of E3SM will generally not be accepted.

#### **Do you intend to add a new feature or change an existing one?**

* We may not have the resources to test/evaluate new or changed features from
non-staff.  Your feature PR will get attention if its part of the E3SM science
plan and coordinated by its management. 

* If you would like to collaborate on E3SM development, see [E3SM
Collaboration](http://e3sm.org/about/collaboration/)

#### **Do you have questions about the source code?**

See our documentation at [e3sm.org](https://e3sm.org).
