# cime
Common Infrastructure for Modeling the Earth

CIME, pronounced “SEAM”, contains the support scripts (configure, build, run, test), data models, essential
utility libraries, a “main” and other tools that are needed to build a single-executable coupled Earth System Model.
CIME is available in a stand-alone package that can be compiled and tested without active prognostic components
but is typically included in the source of a climate model. CIME does not contain: any active components,
any intra-component coupling capability (such as atmosphere physics-dynamics coupling).

*cime* (pronounced: seem) is currently used by the
<a href="http://www2.cesm.ucar.edu">Community Earth System Model </a>
     (CESM) and the <a href="https://climatemodeling.science.energy.gov/projects/energy-exascale-earth-system-model">
Energy Exascale Earth System Model</a> (E3SM).

# Documentation

See <a href="http://esmci.github.io/cime">esmci.github.io/cime</a>

# Developers

## Lead Developers
Case Control System: Jim Edwards (NCAR), Jim Foucar (SNL)

MCT-based Coupler/Driver:  Mariana Vertenstein (NCAR), Robert Jacob (ANL)

Data Models:  Mariana Vertenstein (NCAR)

## Also Developed by
Alice Bertini (NCAR), Tony Craig (NCAR), Michael Deakin (SNL), Chris Fischer (NCAR), Steve Goldhaber (NCAR),
Erich Foster (SNL), Mike Levy (NCAR), Bill Sacks (NCAR), Andrew Salinger (SNL), Sean Santos (NCAR), Jason Sarich (ANL),
Andreas Wilke (ANL).

# Acknowledgements

CIME is jointly developed with support from the Earth System Modeling program of DOE's BER office and the CESM program
of NSF's Division of Atmospheric and Geospace Sciences.

# License

CIME is free software made available under the BSD License. For details see the LICENSE file.
