
SET (CMAKE_Fortran_COMPILER mpiifort CACHE FILEPATH "")
SET (CMAKE_C_COMPILER mpiicc CACHE FILEPATH "")
SET (CMAKE_CXX_COMPILER mpiicpc CACHE FILEPATH "")

SET (NETCDF_DIR $ENV{NETCDF_FORTRAN_PATH} CACHE FILEPATH "")
SET (PNETCDF_DIR $ENV{PNETCDF_PATH} CACHE FILEPATH "")
EXECUTE_PROCESS(COMMAND ${NETCDF_DIR}/bin/nf-config --flibs
  RESULT_VARIABLE NFCONFIG_RESULT
  OUTPUT_VARIABLE NFCONFIG_OUTPUT
  ERROR_VARIABLE  NFCONFIG_ERROR
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
IF (${NFCONFIG_ERROR})
  MESSAGE(WARNING "${NETCDF_DIR}/bin/nf-config --flibs produced an error. Default linking will be used.")
ELSE ()
  SET (ADD_LINKER_FLAGS " ${NFCONFIG_OUTPUT} " CACHE STRING "")
ENDIF ()

SET (HOMME_USE_MKL "TRUE" CACHE FILEPATH "") # for Intel
SET (USE_QUEUING FALSE CACHE BOOL "")
SET (CPRNC_DIR /lcrc/group/acme/tools/cprnc CACHE FILEPATH "")

